Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 336755 - net-analyzer/ethloop _FORTIFY_SOURCE indicates presence of overflow
Summary: net-analyzer/ethloop _FORTIFY_SOURCE indicates presence of overflow
Status: RESOLVED FIXED
Alias: None
Product: Gentoo Linux
Classification: Unclassified
Component: Current packages (show other bugs)
Hardware: All Linux
: High major (vote)
Assignee: Netmon Herd
URL:
Whiteboard:
Keywords: STABLEREQ
Depends on:
Blocks: fortify-source
  Show dependency tree
 
Reported: 2010-09-10 18:19 UTC by Diego Elio Pettenò (RETIRED)
Modified: 2010-12-31 21:23 UTC (History)
2 users (show)

See Also:
Package list:
Runtime testing required: ---


Attachments
Build log (ethloop-10-r1:20100910-171216.log,2.39 KB, text/plain)
2010-09-10 18:19 UTC, Diego Elio Pettenò (RETIRED)
Details
Build log (ethloop-10-r2:20101225-150340.log,2.81 KB, text/plain)
2010-12-26 15:11 UTC, Diego Elio Pettenò (RETIRED)
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Diego Elio Pettenò (RETIRED) gentoo-dev 2010-09-10 18:19:39 UTC
You're receiving this bug because the package in Summary has produced _FORTIFY_SOURCE related warnings indicating the presence of a sure overflow in a static buffer.

Even though this is not always an indication of a security problem it might even be. So please check this out ASAP.

By the way, _FORTIFY_SOURCE is disabled when you disable optimisation, so don't try finding out the cause using -O0.

Thanks,
Your friendly neighborhood tinderboxer
Comment 1 Diego Elio Pettenò (RETIRED) gentoo-dev 2010-09-10 18:19:50 UTC
Created attachment 246745 [details]
Build log
Comment 2 Jeroen Roovers (RETIRED) gentoo-dev 2010-12-01 01:03:40 UTC
Fixed in -r2.
Comment 3 Diego Elio Pettenò (RETIRED) gentoo-dev 2010-12-26 15:10:40 UTC
Still a problem.
Comment 4 Diego Elio Pettenò (RETIRED) gentoo-dev 2010-12-26 15:11:09 UTC
Created attachment 258108 [details]
Build log
Comment 5 Jeroen Roovers (RETIRED) gentoo-dev 2010-12-26 18:45:04 UTC
I don't actually see that output using sys-devel/gcc-4.4.4-r2. How do I make that work?

Sun Dec 26 19:43:52 CET 2010
Portage 2.2.0_alpha10 (default/linux/x86/10.0, gcc-4.4.4, glibc-2.11.2-r3, 2.6.35-gentoo-r12-JeR i686)
=================================================================
                        System Settings
=================================================================
System uname: Linux-2.6.35-gentoo-r12-JeR-i686-Intel-R-_Pentium-R-_4_CPU_2.60GHz-with-gentoo-1.12.14
Timestamp of tree: Sun, 26 Dec 2010 16:45:02 +0000
distcc 3.1 i686-pc-linux-gnu [disabled]
app-shells/bash:     4.1_p7
dev-lang/python:     2.6.6-r1
sys-apps/baselayout: 1.12.14-r1
sys-apps/sandbox:    2.4
sys-devel/autoconf:  2.65-r1
sys-devel/automake:  1.11.1
sys-devel/binutils:  2.20.1-r1
sys-devel/gcc:       4.4.4-r2
sys-devel/gcc-config: 1.4.1
sys-devel/libtool:   2.2.10
sys-devel/make:      3.81-r2
virtual/os-headers:  2.6.30-r1 (sys-kernel/linux-headers)
Repositories: gentoo JeR
ACCEPT_KEYWORDS="x86"
ACCEPT_LICENSE="* -@EULA"
CBUILD="i686-pc-linux-gnu"
CFLAGS="-O2 -march=pentium4 -pipe"
CHOST="i686-pc-linux-gnu"
CONFIG_PROTECT="/etc"
CONFIG_PROTECT_MASK="/etc/ca-certificates.conf /etc/env.d /etc/gconf /etc/revdep-rebuild /etc/sandbox.d /etc/terminfo"
CXXFLAGS="-O2 -march=pentium4 -pipe"
DISTDIR="/aches/distfiles"
FEATURES="assume-digests binpkg-logs buildpkg distlocks fixlafiles fixpackages news notitles parallel-fetch preserve-libs protect-owned sandbox sfperms splitdebug strict test-fail-continue unknown-features-warn unmerge-logs unmerge-orphans userfetch userpriv"
GENTOO_MIRRORS="http://ftp.snt.utwente.nl/pub/os/linux/gentoo http://gentoo.tiscali.nl/"
LC_ALL="en_US.UTF-8"
LDFLAGS="-Wl,-O1 -Wl,--as-needed"
MAKEOPTS="-j2"
PKGDIR="/keeps/gentoo/packages/bastiaan"
PORTAGE_CONFIGROOT="/"
PORTAGE_RSYNC_OPTS="--recursive --links --safe-links --perms --times --compress --force --whole-file --delete --stats --timeout=180 --exclude=/distfiles --exclude=/local --exclude=/packages"
PORTAGE_TMPDIR="/var/tmp"
PORTDIR="/keeps/gentoo/portage"
PORTDIR_OVERLAY="/keeps/gentoo/local"
SYNC="rsync://rsync.gentoo.org/gentoo-portage"
USE="bash-completion berkdb bzip2 cli cracklib crypt cups cxx dri fortran gdbm gpm graphite iconv ipv6 mmx modules mudflap multislot ncurses nethack nls nptl nptlonly openmp pam pcre perl pppd python readline session sse sse2 ssl sysfs tcpd unicode webdav-serf x86 xorg zlib" ALSA_CARDS="ali5451 als4000 atiixp atiixp-modem bt87x ca0106 cmipci emu10k1 emu10k1x ens1370 ens1371 es1938 es1968 fm801 hda-intel intel8x0 intel8x0m maestro3 trident usb-audio via82xx via82xx-modem ymfpci" ALSA_PCM_PLUGINS="adpcm alaw asym copy dmix dshare dsnoop empty extplug file hooks iec958 ioplug ladspa lfloat linear meter mmap_emul mulaw multi null plug rate route share shm softvol" APACHE2_MODULES="actions alias auth_basic authn_alias authn_anon authn_dbm authn_default authn_file authz_dbm authz_default authz_groupfile authz_host authz_owner authz_user autoindex cache cgi cgid dav dav_fs dav_lock deflate dir disk_cache env expires ext_filter file_cache filter headers include info log_config logio mem_cache mime mime_magic negotiation rewrite setenvif speling status unique_id userdir usertrack vhost_alias" COLLECTD_PLUGINS="df interface irq load memory rrdtool swap syslog" ELIBC="glibc" GPSD_PROTOCOLS="ashtech aivdm earthmate evermore fv18 garmin garmintxt gpsclock itrax mtk3301 nmea ntrip navcom oceanserver oldstyle oncore rtcm104v2 rtcm104v3 sirf superstar2 timing tsip tripmate tnt ubx" INPUT_DEVICES="keyboard mouse evdev" KERNEL="linux" LCD_DEVICES="bayrad cfontz cfontz633 glk hd44780 lb216 lcdm001 mtxorb ncurses text" PHP_TARGETS="php5-3" RUBY_TARGETS="ruby18" USERLAND="GNU" VIDEO_CARDS="fbdev glint intel mach64 mga neomagic nouveau nv r128 radeon savage sis tdfx trident vesa via vmware dummy v4l" XTABLES_ADDONS="quota2 psd pknock lscan length2 ipv4options ipset ipp2p iface geoip fuzzy condition tee tarpit sysrq steal rawnat logmark ipmark dhcpmac delude chaos account" 
Unset:  CPPFLAGS, CTARGET, EMERGE_DEFAULT_OPTS, FFLAGS, INSTALL_MASK, LANG, LINGUAS, PORTAGE_BUNZIP2_COMMAND, PORTAGE_COMPRESS, PORTAGE_COMPRESS_FLAGS, PORTAGE_RSYNC_EXTRA_OPTS

=================================================================
                        Package Settings
=================================================================

net-analyzer/ethloop-10-r2 was built with the following:
USE=""


>>> Compiling source in /var/tmp/portage/net-analyzer/ethloop-10-r2/work/ethloop ...
make -j2 CC=i686-pc-linux-gnu-gcc 'CFLAGS=-O2 -march=pentium4 -pipe'
i686-pc-linux-gnu-gcc -O2 -march=pentium4 -pipe  -Wl,-O1 -Wl,--as-needed  ethloop.c   -o
 ethloop     
ethloop.c: In function ‘execprog’:
ethloop.c:240: warning: ignoring return value of ‘system’, declared with attribute warn_
unused_result
ethloop.c: In function ‘main’:
ethloop.c:315: warning: format ‘%d’ expects type ‘int’, but argument 4 has type ‘long un
signed int’  
ethloop.c:346: warning: format ‘%d’ expects type ‘int’, but argument 2 has type ‘long in
t’           
ethloop.c:346: warning: format ‘%d’ expects type ‘int’, but argument 3 has type ‘long in
t’           
ethloop.c:346: warning: format ‘%d’ expects type ‘int’, but argument 4 has type ‘long in
t’           
ethloop.c:346: warning: format ‘%d’ expects type ‘int’, but argument 5 has type ‘long in
t’           
>>> Source compiled.
Comment 6 Diego Elio Pettenò (RETIRED) gentoo-dev 2010-12-26 19:00:58 UTC
Could happen only with 4.5, since the warnings are tied to the constant propagation algorithm.
Comment 7 Jeroen Roovers (RETIRED) gentoo-dev 2010-12-27 17:32:00 UTC
Hm, in the original patch I never actually fixed the recv call itself, despite what the comment and commit messages said. I was staring at that line in the patch all the time without realising the line in question wasn't being patched. :)

Fixed in -r3, and renamed the patch to more aptly refer to gcc 4.5.
Comment 8 Jeroen Roovers (RETIRED) gentoo-dev 2010-12-27 17:33:45 UTC
One more time.

Arch teams, please test and mark stable:
=net-analyzer/ethloop-10-r3
Target KEYWORDS="x86"
Comment 9 Paweł Hajdan, Jr. (RETIRED) gentoo-dev 2010-12-31 19:14:39 UTC
x86 stable